#Mizubaku Daibouken (Sega Saturn) English patcher
#cabbage 2024-05-05
#https://cabbage.cx

import sys
import os

print("\nMizubaku Daibouken (Sega Saturn) English patcher\n\ncabbage 2024.05.05\nhttps://cabbage.cx\n------------------\n")
foo=""#"\nPress enter to exit.\n\n"

#check files...
fcue="Mizubaku Daibouken (Japan).cue"
fbin="Mizubaku Daibouken (Japan) (Track 01).bin"
if os.path.exists(fcue)==False:
    print("Error: File '"+fcue+"' not found.")
    if foo: input(foo)
    sys.exit()
if os.path.exists(fbin)==False:
    print("Error: File '"+fbin+"' not found.")
    if foo: input(foo)
    sys.exit()
length=os.stat(fbin).st_size
if length != 3598560:
    print("Error: Unexpected file size.")
    if foo: input(foo)
    sys.exit()

#patch bin...
sectors=int(length/2352)
data=bytearray()
f=open(fbin,"rb")
for i in range(0,sectors+1):
    f.read(16)
    data+=f.read(2048)
    f.read(288)
f.close()
patch=bytearray([0xe0,0xff,0x2d,0x00,0x00,0x09,0xa0,0x02])
for i in range(len(patch)):
    data[0x1a9e2+i]=patch[i]
f=open(fbin,"wb")
f.write(data)
f.close()
print("File "+fbin+" successfully patched.")

#patch cue...
f=open(fcue,"r")
data=f.readlines()
f.close()
data[1]="  TRACK 01 MODE1/2048\n"
f=open(fcue,"w")
f.writelines(data)
f.close()
print("File "+fcue+" successfully patched.")

#done
print("\nPatching complete.\nEnjoy the game!")
if foo: input(foo)
